package com.test.servlet;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.logging.Logger;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

public class HelloWorldServlet extends HttpServlet {


	private static final long serialVersionUID = -6189108351718996259L;
	
	static Logger log = Logger.getLogger(HelloWorldServlet.class.getName());
	private long waiting = 5;
	
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
    	
    	try {
    		
    		if (null != request.getParameter("waiting") && !request.getParameter("waiting").equals("")) {
    			waiting = Long.parseLong(request.getParameter("waiting"));
    		}
    		
    		System.out.println("FROM SYSTEM.OUT:  Start Wating ====== "+waiting+" ====== ms.");
    		log.info("FROM LOG.INFO:  Start Wating ====== "+waiting+" ====== ms.");
        	
			Thread.sleep(waiting);
			
			System.out.println("FROM SYSTEM.OUT:  End Waiting...");
			log.info("FROM LOG.INFO:  End Waiting...");
			

            // Step 1: Get the Session object
            boolean create = true;
            HttpSession session = request.getSession(create);

            // Step 2: Get the session data value
            Integer ival = (Integer) session.getAttribute("sessiontest.counter");
            if (ival == null) {
                ival = new Integer(1);
            } else {
                ival = new Integer(ival.intValue() + 1);
            }
            session.setAttribute("sessiontest.counter", ival); 

            PrintWriter out = response.getWriter();

            out.println("<html>");
            out.println(" <head>");
            out.println("  <title>Hello World - Servlet Example</title>");
            out.println(" </head>");
            out.println(" <body>");
            out.println("  <h1>Hello, World!</h1>");
            out.println("  <p>Use http://localhost:8080/echo?waiting=888 to setup waiting time</p>");
            out.println("  <br />");
            out.println("  <p>Counter in session:"+String.valueOf((Integer)session.getAttribute("sessiontest.counter"))+" </p>");
            out.println(" </body>");
            out.println("</html>");
	    	
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    }
}
